#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# Code generated by:
# python -m pwiz -e postgresql sdss5db -s astra_050 -iv -o -H localhost -p 6000 -u u0857802
# Date: February 26, 2024 04:01PM
# Database: sdss5db
# Peewee version: 3.17.1

# flake8: noqa: E501,E741

from peewee import (AutoField, BigIntegerField, BigBitField, BitField, BooleanField,
                    DateTimeField, DoubleField, FloatField, ForeignKeyField,
                    IntegerField, SQL, TextField)
from playhouse.postgres_ext import ArrayField

from .. import BaseModel
from . import database  # noqa


class AstraBase(BaseModel):

    class Meta:
        schema = 'astra_050'
        database = database


class Source(AstraBase):
    pk = AutoField()
    sdss_id = BigIntegerField(null=True, unique=True)
    sdss4_apogee_id = TextField(null=True, unique=True)
    gaia_dr2_source_id = BigIntegerField(null=True)
    gaia_dr3_source_id = BigIntegerField(null=True)
    tic_v8_id = BigIntegerField(null=True)
    healpix = IntegerField(null=True)
    lead = TextField(null=True)
    version_id = IntegerField(null=True)
    catalogid = BigIntegerField(null=True)
    catalogid21 = BigIntegerField(null=True)
    catalogid25 = BigIntegerField(null=True)
    catalogid31 = BigIntegerField(null=True)
    n_associated = IntegerField(null=True)
    n_neighborhood = IntegerField()
    sdss5_target_flags = BigBitField(null=True)
    sdss4_apogee_target1_flags = BitField()
    sdss4_apogee_target2_flags = BitField()
    sdss4_apogee2_target1_flags = BitField()
    sdss4_apogee2_target2_flags = BitField()
    sdss4_apogee2_target3_flags = BitField()
    sdss4_apogee_member_flags = BitField()
    sdss4_apogee_extra_target_flags = BitField()
    ra = FloatField(null=True)
    dec = FloatField(null=True)
    plx = FloatField(null=True)
    e_plx = FloatField(null=True)
    pmra = FloatField(null=True)
    e_pmra = FloatField(null=True)
    pmde = FloatField(null=True)
    e_pmde = FloatField(null=True)
    gaia_v_rad = FloatField(null=True)
    gaia_e_v_rad = FloatField(null=True)
    g_mag = FloatField(null=True)
    bp_mag = FloatField(null=True)
    rp_mag = FloatField(null=True)
    j_mag = FloatField(null=True)
    e_j_mag = FloatField(null=True)
    h_mag = FloatField(null=True)
    e_h_mag = FloatField(null=True)
    k_mag = FloatField(null=True)
    e_k_mag = FloatField(null=True)
    ph_qual = TextField(null=True)
    bl_flg = TextField(null=True)
    cc_flg = TextField(null=True)
    w1_flux = FloatField(null=True)
    w1_dflux = FloatField(null=True)
    w2_flux = FloatField(null=True)
    w2_dflux = FloatField(null=True)
    w1_frac = FloatField(null=True)
    w2_frac = FloatField(null=True)
    w1uflags = BitField(null=True)
    w2uflags = BitField(null=True)
    w1aflags = BitField(null=True)
    w2aflags = BitField(null=True)
    mag4_5 = FloatField(null=True)
    d4_5m = FloatField(null=True)
    rms_f4_5 = FloatField(null=True)
    sqf_4_5 = BitField()
    mf4_5 = BitField()
    csf = BitField()
    zgr_teff = FloatField(null=True)
    zgr_e_teff = FloatField(null=True)
    zgr_logg = FloatField(null=True)
    zgr_e_logg = FloatField(null=True)
    zgr_fe_h = FloatField(null=True)
    zgr_e_fe_h = FloatField(null=True)
    zgr_e = FloatField(null=True)
    zgr_e_e = FloatField(null=True)
    zgr_plx = FloatField(null=True)
    zgr_e_plx = FloatField(null=True)
    zgr_teff_confidence = FloatField(null=True)
    zgr_logg_confidence = FloatField(null=True)
    zgr_fe_h_confidence = FloatField(null=True)
    zgr_ln_prior = FloatField(null=True)
    zgr_chi2 = FloatField(null=True)
    zgr_quality_flags = BitField()
    r_med_geo = FloatField(null=True)
    r_lo_geo = FloatField(null=True)
    r_hi_geo = FloatField(null=True)
    r_med_photogeo = FloatField(null=True)
    r_lo_photogeo = FloatField(null=True)
    r_hi_photogeo = FloatField(null=True)
    bailer_jones_flags = TextField(null=True)
    ebv = FloatField(null=True)
    e_ebv = FloatField(null=True)
    ebv_flags = BitField()
    ebv_zhang_2023 = FloatField(null=True)
    e_ebv_zhang_2023 = FloatField(null=True)
    ebv_sfd = FloatField(null=True)
    e_ebv_sfd = FloatField(null=True)
    ebv_rjce_glimpse = FloatField(null=True)
    e_ebv_rjce_glimpse = FloatField(null=True)
    ebv_rjce_allwise = FloatField(null=True)
    e_ebv_rjce_allwise = FloatField(null=True)
    ebv_bayestar_2019 = FloatField(null=True)
    e_ebv_bayestar_2019 = FloatField(null=True)
    ebv_edenhofer_2023 = FloatField(null=True)
    e_ebv_edenhofer_2023 = FloatField(null=True)
    n_boss_visits = IntegerField(null=True)
    n_apogee_visits = IntegerField(null=True)
    boss_min_mjd = IntegerField(null=True)
    boss_max_mjd = IntegerField(null=True)
    apogee_min_mjd = IntegerField(null=True)
    apogee_max_mjd = IntegerField(null=True)
    c_star = DoubleField(null=True)
    u_jkc_mag = DoubleField(null=True)
    u_jkc_mag_flag = IntegerField(null=True)
    b_jkc_mag = DoubleField(null=True)
    b_jkc_mag_flag = IntegerField(null=True)
    v_jkc_mag = DoubleField(null=True)
    v_jkc_mag_flag = IntegerField(null=True)
    r_jkc_mag = DoubleField(null=True)
    r_jkc_mag_flag = IntegerField(null=True)
    i_jkc_mag = DoubleField(null=True)
    i_jkc_mag_flag = IntegerField(null=True)
    u_sdss_mag = DoubleField(null=True)
    u_sdss_mag_flag = IntegerField(null=True)
    r_sdss_mag = DoubleField(null=True)
    r_sdss_mag_flag = IntegerField(null=True)
    i_sdss_mag = DoubleField(null=True)
    i_sdss_mag_flag = IntegerField(null=True)
    z_sdss_mag = DoubleField(null=True)
    z_sdss_mag_flag = IntegerField(null=True)
    y_ps1_mag = DoubleField(null=True)
    y_ps1_mag_flag = IntegerField(null=True)
    g_sdss_mag = DoubleField(null=True)
    g_sdss_mag_flag = IntegerField(null=True)
    l = DoubleField(null=True)
    b = DoubleField(null=True)
    w1_mag = DoubleField(null=True)
    w2_mag = DoubleField(null=True)
    e_w2_mag = DoubleField(null=True)
    e_w1_mag = DoubleField(null=True)

    class Meta:
        table_name = 'source'


class Spectrum(AstraBase):
    pk = AutoField()
    spectrum_type_flags = BigIntegerField()

    class Meta:
        table_name = 'spectrum'


class ApogeeCoaddedSpectrumInApStar(AstraBase):
    pk = AutoField()
    star_pk = BigIntegerField(null=True, unique=True)
    source = ForeignKeyField(column_name='source_pk', field='pk', model=Source, null=True, index=True, backref="apogee_coadded_spectra_in_apstar")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    release = TextField()
    filetype = TextField()
    apred = TextField()
    apstar = TextField()
    obj = TextField()
    telescope = TextField()
    healpix = IntegerField(null=True)
    field = TextField(null=True)
    prefix = TextField(null=True)
    min_mjd = IntegerField(null=True)
    max_mjd = IntegerField(null=True)
    n_entries = IntegerField(null=True)
    n_visits = IntegerField(null=True)
    n_good_visits = IntegerField(null=True)
    n_good_rvs = IntegerField(null=True)
    snr = FloatField(null=True)
    mean_fiber = FloatField(null=True)
    std_fiber = FloatField(null=True)
    spectrum_flags = BigIntegerField()
    v_rad = FloatField(null=True)
    e_v_rad = FloatField(null=True)
    std_v_rad = FloatField(null=True)
    median_e_v_rad = FloatField(null=True)
    doppler_teff = FloatField(null=True)
    doppler_e_teff = FloatField(null=True)
    doppler_logg = FloatField(null=True)
    doppler_e_logg = FloatField(null=True)
    doppler_fe_h = FloatField(null=True)
    doppler_e_fe_h = FloatField(null=True)
    doppler_rchi2 = FloatField(null=True)
    doppler_flags = BigIntegerField()
    xcorr_v_rad = FloatField(null=True)
    xcorr_v_rel = FloatField(null=True)
    xcorr_e_v_rel = FloatField(null=True)
    ccfwhm = FloatField(null=True)
    autofwhm = FloatField(null=True)
    n_components = IntegerField(null=True)

    class Meta:
        table_name = 'apogee_coadded_spectrum_in_ap_star'
        indexes = (
            (('release', 'apred', 'apstar', 'obj', 'telescope', 'healpix', 'field', 'prefix'), True),
        )


class ApogeeCombinedSpectrum(AstraBase):
    pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.apogee_combined_spectrum_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk', field='pk', model=Source, null=True, index=True, backref="apogee_combined_spectrum")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    release = TextField(index=True)
    filetype = TextField()
    v_astra = TextField()
    healpix = IntegerField()
    sdss_id = BigIntegerField(index=True, null=True)
    apred = TextField()
    obj = TextField()
    telescope = TextField()
    min_mjd = IntegerField(null=True)
    max_mjd = IntegerField(null=True)
    n_entries = IntegerField(null=True)
    n_visits = IntegerField(null=True)
    n_good_visits = IntegerField(null=True)
    n_good_rvs = IntegerField(null=True)
    snr = FloatField(null=True)
    mean_fiber = FloatField(null=True)
    std_fiber = FloatField(null=True)
    spectrum_flags = BigIntegerField()
    v_rad = FloatField(null=True)
    e_v_rad = FloatField(null=True)
    std_v_rad = FloatField(null=True)
    median_e_v_rad = FloatField(null=True)
    doppler_teff = FloatField(null=True)
    doppler_e_teff = FloatField(null=True)
    doppler_logg = FloatField(null=True)
    doppler_e_logg = FloatField(null=True)
    doppler_fe_h = FloatField(null=True)
    doppler_e_fe_h = FloatField(null=True)
    doppler_rchi2 = FloatField(null=True)
    doppler_flags = BigIntegerField()
    xcorr_v_rad = FloatField(null=True)
    xcorr_v_rel = FloatField(null=True)
    xcorr_e_v_rel = FloatField(null=True)
    ccfwhm = FloatField(null=True)
    autofwhm = FloatField(null=True)
    n_components = IntegerField(null=True)
    input_spectrum_pks = ArrayField(field_class=IntegerField, index=True, null=True)
    nmf_rchi2 = FloatField(null=True)
    nmf_flags = BigIntegerField()

    class Meta:
        table_name = 'apogee_combined_spectrum'
        indexes = (
            (('release', 'filetype', 'v_astra', 'healpix', 'sdss_id', 'telescope'), True),
        )
        primary_key = False


class ApogeeMadgicsVisitSpectrum(AstraBase):
    pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.apogee_madgics_visit_spectrum_pk_seq'::regclass)")], unique=True)
    spectrum_pk_id = IntegerField(null=True, unique=True)
    drp_spectrum_pk_id = IntegerField(unique=True)
    source_pk = IntegerField(index=True, null=True)
    release = TextField()
    telescope = TextField()
    field = TextField()
    plate = IntegerField()
    mjd = IntegerField()
    fiber = IntegerField()

    class Meta:
        table_name = 'apogee_madgics_visit_spectrum'
        indexes = (
            (('release', 'telescope', 'field', 'plate', 'mjd', 'fiber'), True),
        )
        primary_key = False


class ApogeeNet(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.a_net_task_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk', field='pk', model=Source, null=True, index=True, backref="apogee_net")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    teff = FloatField(null=True)
    e_teff = FloatField(null=True)
    logg = FloatField(null=True)
    e_logg = FloatField(null=True)
    fe_h = FloatField(null=True)
    e_fe_h = FloatField(null=True)
    result_flags = BigIntegerField()
    raw_e_teff = DoubleField(null=True)
    raw_e_logg = DoubleField(null=True)
    raw_e_fe_h = DoubleField(null=True)

    class Meta:
        table_name = 'apogee_net'
        primary_key = False


class ApogeeNetV2(AstraBase):
    task_pk = AutoField()
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="apogeenet_v2")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    teff = FloatField(null=True)
    e_teff = FloatField(null=True)
    logg = FloatField(null=True)
    e_logg = FloatField(null=True)
    fe_h = FloatField(null=True)
    e_fe_h = FloatField(null=True)
    teff_sample_median = FloatField(null=True)
    logg_sample_median = FloatField(null=True)
    fe_h_sample_median = FloatField(null=True)
    result_flags = BigIntegerField()
    raw_e_teff = DoubleField(null=True)
    raw_e_logg = DoubleField(null=True)
    raw_e_fe_h = DoubleField(null=True)

    class Meta:
        table_name = 'apogee_net_v2'


class ApogeeRestFrameVisitSpectrum(AstraBase):
    pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.apogee_rest_frame_visit_spectrum_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk', field='pk', model=Source, null=True, index=True, backref="apogee_restframe_visit_spectra")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    catalogid = BigIntegerField(index=True, null=True)
    star_pk = BigIntegerField(null=True)
    visit_pk = BigIntegerField(null=True)
    rv_visit_pk = BigIntegerField(null=True)
    release = TextField(index=True)
    filetype = TextField()
    v_astra = TextField()
    healpix = IntegerField()
    sdss_id = BigIntegerField(index=True)
    apred = TextField(index=True)
    plate = TextField(index=True)
    telescope = TextField(index=True)
    fiber = IntegerField(index=True)
    mjd = IntegerField(index=True)
    field = TextField(index=True)
    prefix = TextField()
    reduction = TextField()
    obj = TextField(null=True)
    date_obs = DateTimeField(null=True)
    jd = FloatField(null=True)
    exptime = FloatField(null=True)
    dithered = BooleanField(null=True)
    f_night_time = FloatField(null=True)
    input_ra = FloatField(null=True)
    input_dec = FloatField(null=True)
    n_frames = IntegerField(null=True)
    assigned = IntegerField(null=True)
    on_target = IntegerField(null=True)
    valid = IntegerField(null=True)
    fps = BooleanField(null=True)
    snr = FloatField(null=True)
    spectrum_flags = BigIntegerField()
    v_rad = FloatField(null=True)
    v_rel = FloatField(null=True)
    e_v_rel = FloatField(null=True)
    bc = FloatField(null=True)
    doppler_teff = FloatField(null=True)
    doppler_e_teff = FloatField(null=True)
    doppler_logg = FloatField(null=True)
    doppler_e_logg = FloatField(null=True)
    doppler_fe_h = FloatField(null=True)
    doppler_e_fe_h = FloatField(null=True)
    doppler_rchi2 = FloatField(null=True)
    doppler_flags = BigIntegerField()
    xcorr_v_rad = FloatField(null=True)
    xcorr_v_rel = FloatField(null=True)
    xcorr_e_v_rel = FloatField(null=True)
    ccfwhm = FloatField(null=True)
    autofwhm = FloatField(null=True)
    n_components = IntegerField(null=True)
    nmf_rchi2 = FloatField(null=True)
    nmf_flags = BigIntegerField()

    class Meta:
        table_name = 'apogee_rest_frame_visit_spectrum'
        indexes = (
            (('release', 'v_astra', 'sdss_id', 'apred', 'mjd', 'plate', 'telescope', 'field', 'fiber', 'prefix', 'reduction'), True),
        )
        primary_key = False


class ApogeeVisitSpectrum(AstraBase):
    pk = AutoField()
    source = ForeignKeyField(column_name='source_pk', field='pk', model=Source, null=True, index=True, backref="apogee_visit_spectrum")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    catalogid = BigIntegerField(index=True, null=True)
    star_pk = BigIntegerField(null=True)
    visit_pk = BigIntegerField(null=True, unique=True)
    rv_visit_pk = BigIntegerField(null=True, unique=True)
    release = TextField(index=True)
    filetype = TextField()
    apred = TextField(index=True)
    plate = TextField(index=True)
    telescope = TextField(index=True)
    fiber = IntegerField(index=True)
    mjd = IntegerField(index=True)
    field = TextField(index=True)
    prefix = TextField()
    reduction = TextField()
    obj = TextField(null=True)
    date_obs = DateTimeField(null=True)
    jd = FloatField(null=True)
    exptime = FloatField(null=True)
    dithered = BooleanField(null=True)
    f_night_time = FloatField(null=True)
    input_ra = FloatField(null=True)
    input_dec = FloatField(null=True)
    n_frames = IntegerField(null=True)
    assigned = IntegerField(null=True)
    on_target = IntegerField(null=True)
    valid = IntegerField(null=True)
    fps = BooleanField(null=True)
    snr = FloatField(null=True)
    spectrum_flags = BigIntegerField()
    v_rad = FloatField(null=True)
    v_rel = FloatField(null=True)
    e_v_rel = FloatField(null=True)
    bc = FloatField(null=True)
    doppler_teff = FloatField(null=True)
    doppler_e_teff = FloatField(null=True)
    doppler_logg = FloatField(null=True)
    doppler_e_logg = FloatField(null=True)
    doppler_fe_h = FloatField(null=True)
    doppler_e_fe_h = FloatField(null=True)
    doppler_rchi2 = FloatField(null=True)
    doppler_flags = BigIntegerField()
    xcorr_v_rad = FloatField(null=True)
    xcorr_v_rel = FloatField(null=True)
    xcorr_e_v_rel = FloatField(null=True)
    ccfwhm = FloatField(null=True)
    autofwhm = FloatField(null=True)
    n_components = IntegerField(null=True)

    class Meta:
        table_name = 'apogee_visit_spectrum'
        indexes = (
            (('release', 'apred', 'mjd', 'plate', 'telescope', 'field', 'fiber', 'prefix', 'reduction'), True),
        )


class ApogeeVisitSpectrumInApStar(AstraBase):
    pk = AutoField()
    source = ForeignKeyField(column_name='source_pk', field='pk', model=Source, null=True, index=True, backref="apogee_visit_spectrum_in_apstar")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    drp_spectrum_pk_id = IntegerField(unique=True)
    release = TextField()
    filetype = TextField()
    apred = TextField()
    apstar = TextField()
    obj = TextField()
    telescope = TextField()
    healpix = IntegerField(null=True)
    field = TextField(null=True)
    prefix = TextField(null=True)
    plate = TextField()
    mjd = IntegerField()
    fiber = IntegerField()
    reduction = TextField(null=True)

    class Meta:
        table_name = 'apogee_visit_spectrum_in_ap_star'
        indexes = (
            (('release', 'apred', 'apstar', 'obj', 'telescope', 'healpix', 'field', 'prefix', 'plate', 'mjd', 'fiber'), True),
        )


class Aspcap(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.aspcap_task_pk_seq2'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="aspcap")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField()
    irfm_teff = FloatField(null=True)
    irfm_teff_flags = BigIntegerField()
    teff = FloatField(null=True)
    e_teff = FloatField(null=True)
    logg = FloatField(null=True)
    e_logg = FloatField(null=True)
    v_micro = FloatField(null=True)
    e_v_micro = FloatField(null=True)
    v_sini = FloatField(null=True)
    e_v_sini = FloatField(null=True)
    m_h_atm = FloatField(null=True)
    e_m_h_atm = FloatField(null=True)
    alpha_m_atm = FloatField(null=True)
    e_alpha_m_atm = FloatField(null=True)
    c_m_atm = FloatField(null=True)
    e_c_m_atm = FloatField(null=True)
    n_m_atm = FloatField(null=True)
    e_n_m_atm = FloatField(null=True)
    al_h = FloatField(null=True)
    e_al_h = FloatField(null=True)
    al_h_flags = BigIntegerField()
    al_h_rchi2 = FloatField(null=True)
    c_12_13 = FloatField(null=True)
    e_c_12_13 = FloatField(null=True)
    c_12_13_flags = BigIntegerField()
    c_12_13_rchi2 = FloatField(null=True)
    ca_h = FloatField(null=True)
    e_ca_h = FloatField(null=True)
    ca_h_flags = BigIntegerField()
    ca_h_rchi2 = FloatField(null=True)
    ce_h = FloatField(null=True)
    e_ce_h = FloatField(null=True)
    ce_h_flags = BigIntegerField()
    ce_h_rchi2 = FloatField(null=True)
    c_1_h = FloatField(null=True)
    e_c_1_h = FloatField(null=True)
    c_1_h_flags = BigIntegerField()
    c_1_h_rchi2 = FloatField(null=True)
    c_h = FloatField(null=True)
    e_c_h = FloatField(null=True)
    c_h_flags = BigIntegerField()
    c_h_rchi2 = FloatField(null=True)
    co_h = FloatField(null=True)
    e_co_h = FloatField(null=True)
    co_h_flags = BigIntegerField()
    co_h_rchi2 = FloatField(null=True)
    cr_h = FloatField(null=True)
    e_cr_h = FloatField(null=True)
    cr_h_flags = BigIntegerField()
    cr_h_rchi2 = FloatField(null=True)
    cu_h = FloatField(null=True)
    e_cu_h = FloatField(null=True)
    cu_h_flags = BigIntegerField()
    cu_h_rchi2 = FloatField(null=True)
    fe_h = FloatField(null=True)
    e_fe_h = FloatField(null=True)
    fe_h_flags = BigIntegerField()
    fe_h_rchi2 = FloatField(null=True)
    k_h = FloatField(null=True)
    e_k_h = FloatField(null=True)
    k_h_flags = BigIntegerField()
    k_h_rchi2 = FloatField(null=True)
    mg_h = FloatField(null=True)
    e_mg_h = FloatField(null=True)
    mg_h_flags = BigIntegerField()
    mg_h_rchi2 = FloatField(null=True)
    mn_h = FloatField(null=True)
    e_mn_h = FloatField(null=True)
    mn_h_flags = BigIntegerField()
    mn_h_rchi2 = FloatField(null=True)
    na_h = FloatField(null=True)
    e_na_h = FloatField(null=True)
    na_h_flags = BigIntegerField()
    na_h_rchi2 = FloatField(null=True)
    nd_h = FloatField(null=True)
    e_nd_h = FloatField(null=True)
    nd_h_flags = BigIntegerField()
    nd_h_rchi2 = FloatField(null=True)
    ni_h = FloatField(null=True)
    e_ni_h = FloatField(null=True)
    ni_h_flags = BigIntegerField()
    ni_h_rchi2 = FloatField(null=True)
    n_h = FloatField(null=True)
    e_n_h = FloatField(null=True)
    n_h_flags = BigIntegerField()
    n_h_rchi2 = FloatField(null=True)
    o_h = FloatField(null=True)
    e_o_h = FloatField(null=True)
    o_h_flags = BigIntegerField()
    o_h_rchi2 = FloatField(null=True)
    p_h = FloatField(null=True)
    e_p_h = FloatField(null=True)
    p_h_flags = BigIntegerField()
    p_h_rchi2 = FloatField(null=True)
    si_h = FloatField(null=True)
    e_si_h = FloatField(null=True)
    si_h_flags = BigIntegerField()
    si_h_rchi2 = FloatField(null=True)
    s_h = FloatField(null=True)
    e_s_h = FloatField(null=True)
    s_h_flags = BigIntegerField()
    s_h_rchi2 = FloatField(null=True)
    ti_h = FloatField(null=True)
    e_ti_h = FloatField(null=True)
    ti_h_flags = BigIntegerField()
    ti_h_rchi2 = FloatField(null=True)
    ti_2_h = FloatField(null=True)
    e_ti_2_h = FloatField(null=True)
    ti_2_h_flags = BigIntegerField()
    ti_2_h_rchi2 = FloatField(null=True)
    v_h = FloatField(null=True)
    e_v_h = FloatField(null=True)
    v_h_flags = BigIntegerField()
    v_h_rchi2 = FloatField(null=True)
    short_grid_name = TextField()
    continuum_order = IntegerField()
    continuum_reject = FloatField(null=True)
    interpolation_order = IntegerField()
    initial_flags = BigIntegerField()
    snr = FloatField(null=True)
    rchi2 = FloatField(null=True)
    ferre_log_snr_sq = FloatField(null=True)
    ferre_time_elapsed = FloatField(null=True)
    result_flags = BigIntegerField()
    stellar_parameters_task_pk_id = IntegerField(null=True)
    al_h_task_pk_id = IntegerField(null=True)
    c_12_13_task_pk_id = IntegerField(null=True)
    ca_h_task_pk_id = IntegerField(null=True)
    ce_h_task_pk_id = IntegerField(null=True)
    c_1_h_task_pk_id = IntegerField(null=True)
    c_h_task_pk_id = IntegerField(null=True)
    co_h_task_pk_id = IntegerField(null=True)
    cr_h_task_pk_id = IntegerField(null=True)
    cu_h_task_pk_id = IntegerField(null=True)
    fe_h_task_pk_id = IntegerField(null=True)
    k_h_task_pk_id = IntegerField(null=True)
    mg_h_task_pk_id = IntegerField(null=True)
    mn_h_task_pk_id = IntegerField(null=True)
    na_h_task_pk_id = IntegerField(null=True)
    nd_h_task_pk_id = IntegerField(null=True)
    ni_h_task_pk_id = IntegerField(null=True)
    n_h_task_pk_id = IntegerField(null=True)
    o_h_task_pk_id = IntegerField(null=True)
    p_h_task_pk_id = IntegerField(null=True)
    si_h_task_pk_id = IntegerField(null=True)
    s_h_task_pk_id = IntegerField(null=True)
    ti_h_task_pk_id = IntegerField(null=True)
    ti_2_h_task_pk_id = IntegerField(null=True)
    v_h_task_pk_id = IntegerField(null=True)
    calibrated_flags = BigIntegerField(null=True)
    mass = FloatField(null=True)
    radius = FloatField(null=True)
    raw_teff = FloatField(null=True)
    raw_e_teff = FloatField(null=True)
    raw_logg = FloatField(null=True)
    raw_e_logg = FloatField(null=True)
    raw_v_micro = FloatField(null=True)
    raw_e_v_micro = FloatField(null=True)
    raw_v_sini = FloatField(null=True)
    raw_e_v_sini = FloatField(null=True)
    raw_m_h_atm = FloatField(null=True)
    raw_e_m_h_atm = FloatField(null=True)
    raw_alpha_m_atm = FloatField(null=True)
    raw_e_alpha_m_atm = FloatField(null=True)
    raw_c_m_atm = FloatField(null=True)
    raw_e_c_m_atm = FloatField(null=True)
    raw_n_m_atm = FloatField(null=True)
    raw_e_n_m_atm = FloatField(null=True)
    raw_al_h = FloatField(null=True)
    raw_e_al_h = FloatField(null=True)
    raw_c_12_13 = FloatField(null=True)
    raw_e_c_12_13 = FloatField(null=True)
    raw_ca_h = FloatField(null=True)
    raw_e_ca_h = FloatField(null=True)
    raw_ce_h = FloatField(null=True)
    raw_e_ce_h = FloatField(null=True)
    raw_c_1_h = FloatField(null=True)
    raw_e_c_1_h = FloatField(null=True)
    raw_c_h = FloatField(null=True)
    raw_e_c_h = FloatField(null=True)
    raw_co_h = FloatField(null=True)
    raw_e_co_h = FloatField(null=True)
    raw_cr_h = FloatField(null=True)
    raw_e_cr_h = FloatField(null=True)
    raw_cu_h = FloatField(null=True)
    raw_e_cu_h = FloatField(null=True)
    raw_fe_h = FloatField(null=True)
    raw_e_fe_h = FloatField(null=True)
    raw_k_h = FloatField(null=True)
    raw_e_k_h = FloatField(null=True)
    raw_mg_h = FloatField(null=True)
    raw_e_mg_h = FloatField(null=True)
    raw_mn_h = FloatField(null=True)
    raw_e_mn_h = FloatField(null=True)
    raw_na_h = FloatField(null=True)
    raw_e_na_h = FloatField(null=True)
    raw_nd_h = FloatField(null=True)
    raw_e_nd_h = FloatField(null=True)
    raw_ni_h = FloatField(null=True)
    raw_e_ni_h = FloatField(null=True)
    raw_n_h = FloatField(null=True)
    raw_e_n_h = FloatField(null=True)
    raw_o_h = FloatField(null=True)
    raw_e_o_h = FloatField(null=True)
    raw_p_h = FloatField(null=True)
    raw_e_p_h = FloatField(null=True)
    raw_si_h = FloatField(null=True)
    raw_e_si_h = FloatField(null=True)
    raw_s_h = FloatField(null=True)
    raw_e_s_h = FloatField(null=True)
    raw_ti_h = FloatField(null=True)
    raw_e_ti_h = FloatField(null=True)
    raw_ti_2_h = FloatField(null=True)
    raw_e_ti_2_h = FloatField(null=True)
    raw_v_h = FloatField(null=True)
    raw_e_v_h = FloatField(null=True)

    class Meta:
        table_name = 'aspcap'
        primary_key = False


class AstroNNdist(AstraBase):

    class Meta:
        table_name = 'astro_n_ndist'
        primary_key = False


class AstroNn(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.astro_nn_task_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="astro_nn")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    teff = FloatField(null=True)
    e_teff = FloatField(null=True)
    logg = FloatField(null=True)
    e_logg = FloatField(null=True)
    c_h = FloatField(null=True)
    e_c_h = FloatField(null=True)
    c_1_h = FloatField(null=True)
    e_c_1_h = FloatField(null=True)
    n_h = FloatField(null=True)
    e_n_h = FloatField(null=True)
    o_h = FloatField(null=True)
    e_o_h = FloatField(null=True)
    na_h = FloatField(null=True)
    e_na_h = FloatField(null=True)
    mg_h = FloatField(null=True)
    e_mg_h = FloatField(null=True)
    al_h = FloatField(null=True)
    e_al_h = FloatField(null=True)
    si_h = FloatField(null=True)
    e_si_h = FloatField(null=True)
    p_h = FloatField(null=True)
    e_p_h = FloatField(null=True)
    s_h = FloatField(null=True)
    e_s_h = FloatField(null=True)
    k_h = FloatField(null=True)
    e_k_h = FloatField(null=True)
    ca_h = FloatField(null=True)
    e_ca_h = FloatField(null=True)
    ti_h = FloatField(null=True)
    e_ti_h = FloatField(null=True)
    ti_2_h = FloatField(null=True)
    e_ti_2_h = FloatField(null=True)
    v_h = FloatField(null=True)
    e_v_h = FloatField(null=True)
    cr_h = FloatField(null=True)
    e_cr_h = FloatField(null=True)
    mn_h = FloatField(null=True)
    e_mn_h = FloatField(null=True)
    fe_h = FloatField(null=True)
    e_fe_h = FloatField(null=True)
    co_h = FloatField(null=True)
    e_co_h = FloatField(null=True)
    ni_h = FloatField(null=True)
    e_ni_h = FloatField(null=True)
    result_flags = BigIntegerField()

    class Meta:
        table_name = 'astro_nn'
        primary_key = False


class BossCombinedSpectrum(AstraBase):
    pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.boss_combined_spectrum_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk', field='pk', model=Source, null=True, index=True, backref="boss_combined_spectrum")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    release = TextField(index=True)
    filetype = TextField()
    v_astra = TextField()
    healpix = IntegerField(null=True)
    sdss_id = BigIntegerField(index=True)
    run2d = TextField()
    telescope = TextField(index=True)
    min_mjd = IntegerField(null=True)
    max_mjd = IntegerField(null=True)
    n_visits = IntegerField(null=True)
    n_good_visits = IntegerField(null=True)
    n_good_rvs = IntegerField(null=True)
    v_rad = FloatField(null=True)
    e_v_rad = FloatField(null=True)
    std_v_rad = FloatField(null=True)
    median_e_v_rad = FloatField(null=True)
    xcsao_teff = FloatField(null=True)
    xcsao_e_teff = FloatField(null=True)
    xcsao_logg = FloatField(null=True)
    xcsao_e_logg = FloatField(null=True)
    xcsao_fe_h = FloatField(null=True)
    xcsao_e_fe_h = FloatField(null=True)
    xcsao_meanrxc = FloatField(null=True)
    snr = FloatField(null=True)
    gri_gaia_transform_flags = BigIntegerField()
    zwarning_flags = BigIntegerField()
    nmf_rchi2 = FloatField(null=True)
    nmf_flags = BigIntegerField()

    class Meta:
        table_name = 'boss_combined_spectrum'
        indexes = (
            (('release', 'filetype', 'v_astra', 'healpix', 'sdss_id', 'telescope'), True),
        )
        primary_key = False


class BossNet(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.b_net_task_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="boss_net")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    teff = FloatField(null=True)
    e_teff = FloatField(null=True)
    logg = FloatField(null=True)
    e_logg = FloatField(null=True)
    fe_h = FloatField(null=True)
    e_fe_h = FloatField(null=True)
    result_flags = BigIntegerField()
    v_rad = FloatField(null=True)
    e_v_rad = FloatField(null=True)

    class Meta:
        table_name = 'boss_net'
        primary_key = False


class BossRestFrameVisitSpectrum(AstraBase):
    pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.boss_rest_frame_visit_spectrum_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk', field='pk', model=Source, null=True, index=True, backref="boss_restframe_visit_spectrum")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    drp_spectrum_pk_id = IntegerField(unique=True)
    release = TextField(index=True)
    filetype = TextField()
    v_astra = TextField()
    healpix = IntegerField(null=True)
    sdss_id = BigIntegerField(index=True)
    run2d = TextField()
    mjd = IntegerField()
    fieldid = IntegerField()
    catalogid = BigIntegerField()
    n_exp = IntegerField(null=True)
    exptime = FloatField(null=True)
    plateid = IntegerField(null=True)
    cartid = IntegerField(null=True)
    mapid = IntegerField(null=True)
    slitid = IntegerField(null=True)
    psfsky = IntegerField(null=True)
    preject = FloatField(null=True)
    n_std = IntegerField(null=True)
    n_gal = IntegerField(null=True)
    lowrej = IntegerField(null=True)
    highrej = IntegerField(null=True)
    scatpoly = IntegerField(null=True)
    proftype = IntegerField(null=True)
    nfitpoly = IntegerField(null=True)
    skychi2 = FloatField(null=True)
    schi2min = FloatField(null=True)
    schi2max = FloatField(null=True)
    alt = FloatField(null=True)
    az = FloatField(null=True)
    telescope = TextField(null=True)
    seeing = FloatField(null=True)
    airmass = FloatField(null=True)
    airtemp = FloatField(null=True)
    dewpoint = FloatField(null=True)
    humidity = FloatField(null=True)
    pressure = FloatField(null=True)
    dust_a = FloatField(null=True)
    dust_b = FloatField(null=True)
    gust_direction = FloatField(null=True)
    gust_speed = FloatField(null=True)
    wind_direction = FloatField(null=True)
    wind_speed = FloatField(null=True)
    moon_dist_mean = FloatField(null=True)
    moon_phase_mean = FloatField(null=True)
    n_guide = IntegerField(null=True)
    tai_beg = BigIntegerField(null=True)
    tai_end = BigIntegerField(null=True)
    fiber_offset = BooleanField(null=True)
    f_night_time = FloatField(null=True)
    delta_ra = ArrayField(index=True, null=True)  # ARRAY
    delta_dec = ArrayField(index=True, null=True)  # ARRAY
    snr = FloatField(null=True)
    in_stack = BooleanField()
    gri_gaia_transform_flags = BigIntegerField()
    zwarning_flags = BigIntegerField()
    xcsao_v_rad = FloatField(null=True)
    xcsao_e_v_rad = FloatField(null=True)
    xcsao_teff = FloatField(null=True)
    xcsao_e_teff = FloatField(null=True)
    xcsao_logg = FloatField(null=True)
    xcsao_e_logg = FloatField(null=True)
    xcsao_fe_h = FloatField(null=True)
    xcsao_e_fe_h = FloatField(null=True)
    xcsao_rxc = FloatField(null=True)
    nmf_rchi2 = FloatField(null=True)
    nmf_flags = BigIntegerField()

    class Meta:
        table_name = 'boss_rest_frame_visit_spectrum'
        indexes = (
            (('v_astra', 'filetype', 'release', 'run2d', 'fieldid', 'mjd', 'catalogid'), True),
        )
        primary_key = False


class BossVisitSpectrum(AstraBase):
    pk = AutoField()
    source = ForeignKeyField(column_name='source_pk', field='pk', model=Source, null=True, index=True, backref="boss_visit_spectrum")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    release = TextField()
    filetype = TextField()
    run2d = TextField()
    mjd = IntegerField()
    fieldid = IntegerField()
    catalogid = BigIntegerField()
    healpix = IntegerField()
    n_exp = IntegerField(null=True)
    exptime = FloatField(null=True)
    plateid = IntegerField(null=True)
    cartid = IntegerField(null=True)
    mapid = IntegerField(null=True)
    slitid = IntegerField(null=True)
    psfsky = IntegerField(null=True)
    preject = FloatField(null=True)
    n_std = IntegerField(null=True)
    n_gal = IntegerField(null=True)
    lowrej = IntegerField(null=True)
    highrej = IntegerField(null=True)
    scatpoly = IntegerField(null=True)
    proftype = IntegerField(null=True)
    nfitpoly = IntegerField(null=True)
    skychi2 = FloatField(null=True)
    schi2min = FloatField(null=True)
    schi2max = FloatField(null=True)
    alt = FloatField(null=True)
    az = FloatField(null=True)
    telescope = TextField(null=True)
    seeing = FloatField(null=True)
    airmass = FloatField(null=True)
    airtemp = FloatField(null=True)
    dewpoint = FloatField(null=True)
    humidity = FloatField(null=True)
    pressure = FloatField(null=True)
    dust_a = FloatField(null=True)
    dust_b = FloatField(null=True)
    gust_direction = FloatField(null=True)
    gust_speed = FloatField(null=True)
    wind_direction = FloatField(null=True)
    wind_speed = FloatField(null=True)
    moon_dist_mean = FloatField(null=True)
    moon_phase_mean = FloatField(null=True)
    n_guide = IntegerField(null=True)
    tai_beg = BigIntegerField(null=True)
    tai_end = BigIntegerField(null=True)
    fiber_offset = BooleanField(null=True)
    f_night_time = FloatField(null=True)
    delta_ra = ArrayField(index=True, null=True)  # ARRAY
    delta_dec = ArrayField(index=True, null=True)  # ARRAY
    snr = FloatField(null=True)
    gri_gaia_transform_flags = BigIntegerField()
    zwarning_flags = BigIntegerField()
    xcsao_v_rad = FloatField(null=True)
    xcsao_e_v_rad = FloatField(null=True)
    xcsao_teff = FloatField(null=True)
    xcsao_e_teff = FloatField(null=True)
    xcsao_logg = FloatField(null=True)
    xcsao_e_logg = FloatField(null=True)
    xcsao_fe_h = FloatField(null=True)
    xcsao_e_fe_h = FloatField(null=True)
    xcsao_rxc = FloatField(null=True)

    class Meta:
        table_name = 'boss_visit_spectrum'
        indexes = (
            (('release', 'run2d', 'fieldid', 'mjd', 'catalogid'), True),
        )


class Corv(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.corv_task_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="corv")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    v_rad = FloatField(null=True)
    e_v_rad = FloatField(null=True)
    teff = FloatField(null=True)
    e_teff = FloatField(null=True)
    logg = FloatField(null=True)
    e_logg = FloatField(null=True)
    initial_teff = FloatField(null=True)
    initial_logg = FloatField(null=True)
    initial_v_rad = FloatField(null=True)
    rchi2 = FloatField(null=True)
    result_flags = IntegerField(constraints=[SQL("DEFAULT 0")], null=True)

    class Meta:
        table_name = 'corv'
        primary_key = False


class FerreChemicalAbundances(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.ferre_chemical_abundances_task_pk_seq1'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="ferre_chemical_abundances")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    upstream_pk = IntegerField()
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField()
    pwd = TextField()
    short_grid_name = TextField()
    header_path = TextField()
    initial_teff = FloatField(null=True)
    initial_logg = FloatField(null=True)
    initial_m_h = FloatField(null=True)
    initial_log10_v_sini = FloatField(null=True)
    initial_log10_v_micro = FloatField(null=True)
    initial_alpha_m = FloatField(null=True)
    initial_c_m = FloatField(null=True)
    initial_n_m = FloatField(null=True)
    initial_flags = BigIntegerField()
    continuum_order = IntegerField()
    continuum_reject = FloatField(null=True)
    continuum_flag = IntegerField(null=True)
    continuum_observations_flag = IntegerField(null=True)
    interpolation_order = IntegerField()
    weight_path = TextField()
    frozen_flags = BigIntegerField()
    f_access = IntegerField()
    f_format = IntegerField()
    n_threads = IntegerField()
    teff = FloatField(null=True)
    e_teff = FloatField(null=True)
    logg = FloatField(null=True)
    e_logg = FloatField(null=True)
    m_h = FloatField(null=True)
    e_m_h = FloatField(null=True)
    log10_v_sini = FloatField(null=True)
    e_log10_v_sini = FloatField(null=True)
    log10_v_micro = FloatField(null=True)
    e_log10_v_micro = FloatField(null=True)
    alpha_m = FloatField(null=True)
    e_alpha_m = FloatField(null=True)
    c_m = FloatField(null=True)
    e_c_m = FloatField(null=True)
    n_m = FloatField(null=True)
    e_n_m = FloatField(null=True)
    ferre_name = TextField()
    ferre_input_index = IntegerField()
    ferre_output_index = IntegerField()
    ferre_n_obj = IntegerField()
    snr = FloatField(null=True)
    rchi2 = FloatField(null=True)
    penalized_rchi2 = FloatField(null=True)
    ferre_log_snr_sq = FloatField(null=True)
    ferre_time_load_grid = FloatField(null=True)
    ferre_time_elapsed = FloatField(null=True)
    ferre_flags = BigIntegerField()

    class Meta:
        table_name = 'ferre_chemical_abundances'
        primary_key = False


class FerreCoarse(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.ferre_coarse_task_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="ferre_coarse")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    pwd = TextField()
    short_grid_name = TextField()
    header_path = TextField()
    initial_teff = FloatField(null=True)
    initial_logg = FloatField(null=True)
    initial_m_h = FloatField(null=True)
    initial_log10_v_sini = FloatField(null=True)
    initial_log10_v_micro = FloatField(null=True)
    initial_alpha_m = FloatField(null=True)
    initial_c_m = FloatField(null=True)
    initial_n_m = FloatField(null=True)
    initial_flags = BigIntegerField()
    continuum_order = IntegerField(null=True)
    continuum_reject = FloatField(null=True)
    continuum_flag = IntegerField(null=True)
    continuum_observations_flag = IntegerField(null=True)
    interpolation_order = IntegerField()
    weight_path = TextField()
    frozen_flags = BigIntegerField()
    f_access = IntegerField()
    f_format = IntegerField()
    n_threads = IntegerField()
    teff = FloatField(null=True)
    e_teff = FloatField(null=True)
    logg = FloatField(null=True)
    e_logg = FloatField(null=True)
    m_h = FloatField(null=True)
    e_m_h = FloatField(null=True)
    log10_v_sini = FloatField(null=True)
    e_log10_v_sini = FloatField(null=True)
    log10_v_micro = FloatField(null=True)
    e_log10_v_micro = FloatField(null=True)
    alpha_m = FloatField(null=True)
    e_alpha_m = FloatField(null=True)
    c_m = FloatField(null=True)
    e_c_m = FloatField(null=True)
    n_m = FloatField(null=True)
    e_n_m = FloatField(null=True)
    ferre_name = TextField()
    ferre_input_index = IntegerField()
    ferre_output_index = IntegerField()
    ferre_n_obj = IntegerField()
    snr = FloatField(null=True)
    rchi2 = FloatField(null=True)
    penalized_rchi2 = FloatField(null=True)
    ferre_log_snr_sq = FloatField(null=True)
    ferre_time_load_grid = FloatField(null=True)
    ferre_time_elapsed = FloatField(null=True)
    ferre_flags = BigIntegerField()

    class Meta:
        table_name = 'ferre_coarse'
        primary_key = False


class FerreStellarParameters(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.ferre_stellar_parameters_task_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="ferre_stellar_parameters")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    upstream_pk = IntegerField(index=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    pwd = TextField()
    short_grid_name = TextField()
    header_path = TextField()
    initial_teff = FloatField(null=True)
    initial_logg = FloatField(null=True)
    initial_m_h = FloatField(null=True)
    initial_log10_v_sini = FloatField(null=True)
    initial_log10_v_micro = FloatField(null=True)
    initial_alpha_m = FloatField(null=True)
    initial_c_m = FloatField(null=True)
    initial_n_m = FloatField(null=True)
    initial_flags = BigIntegerField()
    continuum_order = IntegerField()
    continuum_reject = FloatField(null=True)
    continuum_flag = IntegerField(null=True)
    continuum_observations_flag = IntegerField(null=True)
    interpolation_order = IntegerField()
    weight_path = TextField()
    frozen_flags = BigIntegerField()
    f_access = IntegerField()
    f_format = IntegerField()
    n_threads = IntegerField()
    teff = FloatField(null=True)
    e_teff = FloatField(null=True)
    logg = FloatField(null=True)
    e_logg = FloatField(null=True)
    m_h = FloatField(null=True)
    e_m_h = FloatField(null=True)
    log10_v_sini = FloatField(null=True)
    e_log10_v_sini = FloatField(null=True)
    log10_v_micro = FloatField(null=True)
    e_log10_v_micro = FloatField(null=True)
    alpha_m = FloatField(null=True)
    e_alpha_m = FloatField(null=True)
    c_m = FloatField(null=True)
    e_c_m = FloatField(null=True)
    n_m = FloatField(null=True)
    e_n_m = FloatField(null=True)
    ferre_name = TextField()
    ferre_input_index = IntegerField()
    ferre_output_index = IntegerField()
    ferre_n_obj = IntegerField()
    snr = FloatField(null=True)
    rchi2 = FloatField(null=True)
    penalized_rchi2 = FloatField(null=True)
    ferre_log_snr_sq = FloatField(null=True)
    ferre_time_load_grid = FloatField(null=True)
    ferre_time_elapsed = FloatField(null=True)
    ferre_flags = BigIntegerField()

    class Meta:
        table_name = 'ferre_stellar_parameters'
        primary_key = False


class Grok(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.grok_task_pk_seq3'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="grok")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField()
    coarse_teff = FloatField(null=True)
    coarse_logg = FloatField(null=True)
    coarse_c_m = FloatField(null=True)
    coarse_m_h = FloatField(null=True)
    coarse_n_m = FloatField(null=True)
    coarse_v_micro = FloatField(null=True)
    coarse_v_sini = FloatField(null=True)
    coarse_chi2 = FloatField(null=True)
    slice_teff = FloatField(null=True)
    slice_logg = FloatField(null=True)
    slice_c_m = FloatField(null=True)
    slice_m_h = FloatField(null=True)
    slice_n_m = FloatField(null=True)
    slice_v_micro = FloatField(null=True)
    slice_v_sini = FloatField(null=True)
    quad_teff = FloatField(null=True)
    quad_logg = FloatField(null=True)
    quad_c_m = FloatField(null=True)
    quad_m_h = FloatField(null=True)
    quad_n_m = FloatField(null=True)
    quad_v_micro = FloatField(null=True)
    quad_v_sini = FloatField(null=True)
    teff = FloatField(null=True)
    e_teff = FloatField(null=True)
    logg = FloatField(null=True)
    e_logg = FloatField(null=True)
    v_micro = FloatField(null=True)
    e_v_micro = FloatField(null=True)
    m_h = FloatField(null=True)
    e_m_h = FloatField(null=True)
    c_m = FloatField(null=True)
    e_c_m = FloatField(null=True)
    n_m = FloatField(null=True)
    e_n_m = FloatField(null=True)
    v_sini = FloatField(null=True)
    e_v_sini = FloatField(null=True)
    chi2 = FloatField(null=True)
    result_flags = BigIntegerField()

    class Meta:
        table_name = 'grok'
        primary_key = False


class GrokRotation(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.grok_rotation_task_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="grok_rotation")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    vsini = FloatField(null=True)
    chi2 = FloatField(null=True)
    w = ArrayField(column_name='W', null=True)  # ARRAY

    class Meta:
        table_name = 'grok_rotation'
        primary_key = False


class HotPayne(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.hot_payne_task_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="hot_payne")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    teff = FloatField(null=True)
    e_teff = FloatField(null=True)
    logg = FloatField(null=True)
    e_logg = FloatField(null=True)
    fe_h = FloatField(null=True)
    e_fe_h = FloatField(null=True)
    v_micro = FloatField(null=True)
    e_v_micro = FloatField(null=True)
    v_sini = FloatField(null=True)
    e_v_sini = FloatField(null=True)
    he_h = FloatField(null=True)
    e_he_h = FloatField(null=True)
    c_h = FloatField(null=True)
    e_c_h = FloatField(null=True)
    n_h = FloatField(null=True)
    e_n_h = FloatField(null=True)
    o_h = FloatField(null=True)
    e_o_h = FloatField(null=True)
    si_h = FloatField(null=True)
    e_si_h = FloatField(null=True)
    s_h = FloatField(null=True)
    e_s_h = FloatField(null=True)
    covar = ArrayField(index=True)  # ARRAY
    chi2 = FloatField(null=True)
    result_flags = IntegerField()
    teff_fullspec = FloatField(null=True)
    e_teff_fullspec = FloatField(null=True)
    logg_fullspec = FloatField(null=True)
    e_logg_fullspec = FloatField(null=True)
    fe_h_fullspec = FloatField(null=True)
    e_fe_h_fullspec = FloatField(null=True)
    v_micro_fullspec = FloatField(null=True)
    e_v_micro_fullspec = FloatField(null=True)
    v_sini_fullspec = FloatField(null=True)
    e_v_sini_fullspec = FloatField(null=True)
    he_h_fullspec = FloatField(null=True)
    e_he_h_fullspec = FloatField(null=True)
    c_h_fullspec = FloatField(null=True)
    e_c_h_fullspec = FloatField(null=True)
    n_h_fullspec = FloatField(null=True)
    e_n_h_fullspec = FloatField(null=True)
    o_h_fullspec = FloatField(null=True)
    e_o_h_fullspec = FloatField(null=True)
    si_h_fullspec = FloatField(null=True)
    e_si_h_fullspec = FloatField(null=True)
    s_h_fullspec = FloatField(null=True)
    e_s_h_fullspec = FloatField(null=True)
    covar_fullspec = ArrayField(index=True)  # ARRAY
    chi2_fullspec = FloatField(null=True)
    teff_hmasked = FloatField(null=True)
    e_teff_hmasked = FloatField(null=True)
    logg_hmasked = FloatField(null=True)
    e_logg_hmasked = FloatField(null=True)
    fe_h_hmasked = FloatField(null=True)
    e_fe_h_hmasked = FloatField(null=True)
    v_micro_hmasked = FloatField(null=True)
    e_v_micro_hmasked = FloatField(null=True)
    v_sini_hmasked = FloatField(null=True)
    e_v_sini_hmasked = FloatField(null=True)
    he_h_hmasked = FloatField(null=True)
    e_he_h_hmasked = FloatField(null=True)
    c_h_hmasked = FloatField(null=True)
    e_c_h_hmasked = FloatField(null=True)
    n_h_hmasked = FloatField(null=True)
    e_n_h_hmasked = FloatField(null=True)
    o_h_hmasked = FloatField(null=True)
    e_o_h_hmasked = FloatField(null=True)
    si_h_hmasked = FloatField(null=True)
    e_si_h_hmasked = FloatField(null=True)
    s_h_hmasked = FloatField(null=True)
    e_s_h_hmasked = FloatField(null=True)
    covar_hmasked = ArrayField(index=True)  # ARRAY
    chi2_hmasked = FloatField(null=True)
    raw_e_teff = DoubleField(null=True)
    raw_e_logg = DoubleField(null=True)
    raw_e_fe_h = DoubleField(null=True)
    raw_e_v_micro = DoubleField(null=True)
    raw_e_v_sini = DoubleField(null=True)
    raw_e_he_h = DoubleField(null=True)
    raw_e_c_h = DoubleField(null=True)
    raw_e_n_h = DoubleField(null=True)
    raw_e_o_h = DoubleField(null=True)
    raw_e_si_h = DoubleField(null=True)
    raw_e_s_h = DoubleField(null=True)
    raw_e_teff_fullspec = DoubleField(null=True)
    raw_e_logg_fullspec = DoubleField(null=True)
    raw_e_fe_h_fullspec = DoubleField(null=True)
    raw_e_v_micro_fullspec = DoubleField(null=True)
    raw_e_v_sini_fullspec = DoubleField(null=True)
    raw_e_he_h_fullspec = DoubleField(null=True)
    raw_e_c_h_fullspec = DoubleField(null=True)
    raw_e_n_h_fullspec = DoubleField(null=True)
    raw_e_o_h_fullspec = DoubleField(null=True)
    raw_e_si_h_fullspec = DoubleField(null=True)
    raw_e_s_h_fullspec = DoubleField(null=True)
    raw_e_teff_hmasked = DoubleField(null=True)
    raw_e_logg_hmasked = DoubleField(null=True)
    raw_e_fe_h_hmasked = DoubleField(null=True)
    raw_e_v_micro_hmasked = DoubleField(null=True)
    raw_e_v_sini_hmasked = DoubleField(null=True)
    raw_e_he_h_hmasked = DoubleField(null=True)
    raw_e_c_h_hmasked = DoubleField(null=True)
    raw_e_n_h_hmasked = DoubleField(null=True)
    raw_e_o_h_hmasked = DoubleField(null=True)
    raw_e_si_h_hmasked = DoubleField(null=True)
    raw_e_s_h_hmasked = DoubleField(null=True)

    class Meta:
        table_name = 'hot_payne'
        primary_key = False


class LineForest(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.line_forest_task_pk_seq1'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="line_forest")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField()
    eqw_h_alpha = FloatField(null=True)
    abs_h_alpha = FloatField(null=True)
    detection_stat_h_alpha = FloatField(null=True)
    detection_raw_h_alpha = FloatField(null=True)
    eqw_percentiles_h_alpha = ArrayField(null=True)  # ARRAY
    abs_percentiles_h_alpha = ArrayField(null=True)  # ARRAY
    eqw_h_beta = FloatField(null=True)
    abs_h_beta = FloatField(null=True)
    detection_stat_h_beta = FloatField(null=True)
    detection_raw_h_beta = FloatField(null=True)
    eqw_percentiles_h_beta = ArrayField(null=True)  # ARRAY
    abs_percentiles_h_beta = ArrayField(null=True)  # ARRAY
    eqw_h_gamma = FloatField(null=True)
    abs_h_gamma = FloatField(null=True)
    detection_stat_h_gamma = FloatField(null=True)
    detection_raw_h_gamma = FloatField(null=True)
    eqw_percentiles_h_gamma = ArrayField(null=True)  # ARRAY
    abs_percentiles_h_gamma = ArrayField(null=True)  # ARRAY
    eqw_h_delta = FloatField(null=True)
    abs_h_delta = FloatField(null=True)
    detection_stat_h_delta = FloatField(null=True)
    detection_raw_h_delta = FloatField(null=True)
    eqw_percentiles_h_delta = ArrayField(null=True)  # ARRAY
    abs_percentiles_h_delta = ArrayField(null=True)  # ARRAY
    eqw_h_epsilon = FloatField(null=True)
    abs_h_epsilon = FloatField(null=True)
    detection_stat_h_epsilon = FloatField(null=True)
    detection_raw_h_epsilon = FloatField(null=True)
    eqw_percentiles_h_epsilon = ArrayField(null=True)  # ARRAY
    abs_percentiles_h_epsilon = ArrayField(null=True)  # ARRAY
    eqw_h_8 = FloatField(null=True)
    abs_h_8 = FloatField(null=True)
    detection_stat_h_8 = FloatField(null=True)
    detection_raw_h_8 = FloatField(null=True)
    eqw_percentiles_h_8 = ArrayField(null=True)  # ARRAY
    abs_percentiles_h_8 = ArrayField(null=True)  # ARRAY
    eqw_h_9 = FloatField(null=True)
    abs_h_9 = FloatField(null=True)
    detection_stat_h_9 = FloatField(null=True)
    detection_raw_h_9 = FloatField(null=True)
    eqw_percentiles_h_9 = ArrayField(null=True)  # ARRAY
    abs_percentiles_h_9 = ArrayField(null=True)  # ARRAY
    eqw_h_10 = FloatField(null=True)
    abs_h_10 = FloatField(null=True)
    detection_stat_h_10 = FloatField(null=True)
    detection_raw_h_10 = FloatField(null=True)
    eqw_percentiles_h_10 = ArrayField(null=True)  # ARRAY
    abs_percentiles_h_10 = ArrayField(null=True)  # ARRAY
    eqw_h_11 = FloatField(null=True)
    abs_h_11 = FloatField(null=True)
    detection_stat_h_11 = FloatField(null=True)
    detection_raw_h_11 = FloatField(null=True)
    eqw_percentiles_h_11 = ArrayField(null=True)  # ARRAY
    abs_percentiles_h_11 = ArrayField(null=True)  # ARRAY
    eqw_h_12 = FloatField(null=True)
    abs_h_12 = FloatField(null=True)
    detection_stat_h_12 = FloatField(null=True)
    detection_raw_h_12 = FloatField(null=True)
    eqw_percentiles_h_12 = ArrayField(null=True)  # ARRAY
    abs_percentiles_h_12 = ArrayField(null=True)  # ARRAY
    eqw_h_13 = FloatField(null=True)
    abs_h_13 = FloatField(null=True)
    detection_stat_h_13 = FloatField(null=True)
    detection_raw_h_13 = FloatField(null=True)
    eqw_percentiles_h_13 = ArrayField(null=True)  # ARRAY
    abs_percentiles_h_13 = ArrayField(null=True)  # ARRAY
    eqw_h_14 = FloatField(null=True)
    abs_h_14 = FloatField(null=True)
    detection_stat_h_14 = FloatField(null=True)
    detection_raw_h_14 = FloatField(null=True)
    eqw_percentiles_h_14 = ArrayField(null=True)  # ARRAY
    abs_percentiles_h_14 = ArrayField(null=True)  # ARRAY
    eqw_h_15 = FloatField(null=True)
    abs_h_15 = FloatField(null=True)
    detection_stat_h_15 = FloatField(null=True)
    detection_raw_h_15 = FloatField(null=True)
    eqw_percentiles_h_15 = ArrayField(null=True)  # ARRAY
    abs_percentiles_h_15 = ArrayField(null=True)  # ARRAY
    eqw_h_16 = FloatField(null=True)
    abs_h_16 = FloatField(null=True)
    detection_stat_h_16 = FloatField(null=True)
    detection_raw_h_16 = FloatField(null=True)
    eqw_percentiles_h_16 = ArrayField(null=True)  # ARRAY
    abs_percentiles_h_16 = ArrayField(null=True)  # ARRAY
    eqw_h_17 = FloatField(null=True)
    abs_h_17 = FloatField(null=True)
    detection_stat_h_17 = FloatField(null=True)
    detection_raw_h_17 = FloatField(null=True)
    eqw_percentiles_h_17 = ArrayField(null=True)  # ARRAY
    abs_percentiles_h_17 = ArrayField(null=True)  # ARRAY
    eqw_pa_7 = FloatField(null=True)
    abs_pa_7 = FloatField(null=True)
    detection_stat_pa_7 = FloatField(null=True)
    detection_raw_pa_7 = FloatField(null=True)
    eqw_percentiles_pa_7 = ArrayField(null=True)  # ARRAY
    abs_percentiles_pa_7 = ArrayField(null=True)  # ARRAY
    eqw_pa_8 = FloatField(null=True)
    abs_pa_8 = FloatField(null=True)
    detection_stat_pa_8 = FloatField(null=True)
    detection_raw_pa_8 = FloatField(null=True)
    eqw_percentiles_pa_8 = ArrayField(null=True)  # ARRAY
    abs_percentiles_pa_8 = ArrayField(null=True)  # ARRAY
    eqw_pa_9 = FloatField(null=True)
    abs_pa_9 = FloatField(null=True)
    detection_stat_pa_9 = FloatField(null=True)
    detection_raw_pa_9 = FloatField(null=True)
    eqw_percentiles_pa_9 = ArrayField(null=True)  # ARRAY
    abs_percentiles_pa_9 = ArrayField(null=True)  # ARRAY
    eqw_pa_10 = FloatField(null=True)
    abs_pa_10 = FloatField(null=True)
    detection_stat_pa_10 = FloatField(null=True)
    detection_raw_pa_10 = FloatField(null=True)
    eqw_percentiles_pa_10 = ArrayField(null=True)  # ARRAY
    abs_percentiles_pa_10 = ArrayField(null=True)  # ARRAY
    eqw_pa_11 = FloatField(null=True)
    abs_pa_11 = FloatField(null=True)
    detection_stat_pa_11 = FloatField(null=True)
    detection_raw_pa_11 = FloatField(null=True)
    eqw_percentiles_pa_11 = ArrayField(null=True)  # ARRAY
    abs_percentiles_pa_11 = ArrayField(null=True)  # ARRAY
    eqw_pa_12 = FloatField(null=True)
    abs_pa_12 = FloatField(null=True)
    detection_stat_pa_12 = FloatField(null=True)
    detection_raw_pa_12 = FloatField(null=True)
    eqw_percentiles_pa_12 = ArrayField(null=True)  # ARRAY
    abs_percentiles_pa_12 = ArrayField(null=True)  # ARRAY
    eqw_pa_13 = FloatField(null=True)
    abs_pa_13 = FloatField(null=True)
    detection_stat_pa_13 = FloatField(null=True)
    detection_raw_pa_13 = FloatField(null=True)
    eqw_percentiles_pa_13 = ArrayField(null=True)  # ARRAY
    abs_percentiles_pa_13 = ArrayField(null=True)  # ARRAY
    eqw_pa_14 = FloatField(null=True)
    abs_pa_14 = FloatField(null=True)
    detection_stat_pa_14 = FloatField(null=True)
    detection_raw_pa_14 = FloatField(null=True)
    eqw_percentiles_pa_14 = ArrayField(null=True)  # ARRAY
    abs_percentiles_pa_14 = ArrayField(null=True)  # ARRAY
    eqw_pa_15 = FloatField(null=True)
    abs_pa_15 = FloatField(null=True)
    detection_stat_pa_15 = FloatField(null=True)
    detection_raw_pa_15 = FloatField(null=True)
    eqw_percentiles_pa_15 = ArrayField(null=True)  # ARRAY
    abs_percentiles_pa_15 = ArrayField(null=True)  # ARRAY
    eqw_pa_16 = FloatField(null=True)
    abs_pa_16 = FloatField(null=True)
    detection_stat_pa_16 = FloatField(null=True)
    detection_raw_pa_16 = FloatField(null=True)
    eqw_percentiles_pa_16 = ArrayField(null=True)  # ARRAY
    abs_percentiles_pa_16 = ArrayField(null=True)  # ARRAY
    eqw_pa_17 = FloatField(null=True)
    abs_pa_17 = FloatField(null=True)
    detection_stat_pa_17 = FloatField(null=True)
    detection_raw_pa_17 = FloatField(null=True)
    eqw_percentiles_pa_17 = ArrayField(null=True)  # ARRAY
    abs_percentiles_pa_17 = ArrayField(null=True)  # ARRAY
    eqw_ca_ii_8662 = FloatField(null=True)
    abs_ca_ii_8662 = FloatField(null=True)
    detection_stat_ca_ii_8662 = FloatField(null=True)
    detection_raw_ca_ii_8662 = FloatField(null=True)
    eqw_percentiles_ca_ii_8662 = ArrayField(null=True)  # ARRAY
    abs_percentiles_ca_ii_8662 = ArrayField(null=True)  # ARRAY
    eqw_ca_ii_8542 = FloatField(null=True)
    abs_ca_ii_8542 = FloatField(null=True)
    detection_stat_ca_ii_8542 = FloatField(null=True)
    detection_raw_ca_ii_8542 = FloatField(null=True)
    eqw_percentiles_ca_ii_8542 = ArrayField(null=True)  # ARRAY
    abs_percentiles_ca_ii_8542 = ArrayField(null=True)  # ARRAY
    eqw_ca_ii_8498 = FloatField(null=True)
    abs_ca_ii_8498 = FloatField(null=True)
    detection_stat_ca_ii_8498 = FloatField(null=True)
    detection_raw_ca_ii_8498 = FloatField(null=True)
    eqw_percentiles_ca_ii_8498 = ArrayField(null=True)  # ARRAY
    abs_percentiles_ca_ii_8498 = ArrayField(null=True)  # ARRAY
    eqw_ca_k_3933 = FloatField(null=True)
    abs_ca_k_3933 = FloatField(null=True)
    detection_stat_ca_k_3933 = FloatField(null=True)
    detection_raw_ca_k_3933 = FloatField(null=True)
    eqw_percentiles_ca_k_3933 = ArrayField(null=True)  # ARRAY
    abs_percentiles_ca_k_3933 = ArrayField(null=True)  # ARRAY
    eqw_ca_h_3968 = FloatField(null=True)
    abs_ca_h_3968 = FloatField(null=True)
    detection_stat_ca_h_3968 = FloatField(null=True)
    detection_raw_ca_h_3968 = FloatField(null=True)
    eqw_percentiles_ca_h_3968 = ArrayField(null=True)  # ARRAY
    abs_percentiles_ca_h_3968 = ArrayField(null=True)  # ARRAY
    eqw_he_i_6678 = FloatField(null=True)
    abs_he_i_6678 = FloatField(null=True)
    detection_stat_he_i_6678 = FloatField(null=True)
    detection_raw_he_i_6678 = FloatField(null=True)
    eqw_percentiles_he_i_6678 = ArrayField(null=True)  # ARRAY
    abs_percentiles_he_i_6678 = ArrayField(null=True)  # ARRAY
    eqw_he_i_5875 = FloatField(null=True)
    abs_he_i_5875 = FloatField(null=True)
    detection_stat_he_i_5875 = FloatField(null=True)
    detection_raw_he_i_5875 = FloatField(null=True)
    eqw_percentiles_he_i_5875 = ArrayField(null=True)  # ARRAY
    abs_percentiles_he_i_5875 = ArrayField(null=True)  # ARRAY
    eqw_he_i_5015 = FloatField(null=True)
    abs_he_i_5015 = FloatField(null=True)
    detection_stat_he_i_5015 = FloatField(null=True)
    detection_raw_he_i_5015 = FloatField(null=True)
    eqw_percentiles_he_i_5015 = ArrayField(null=True)  # ARRAY
    abs_percentiles_he_i_5015 = ArrayField(null=True)  # ARRAY
    eqw_he_i_4471 = FloatField(null=True)
    abs_he_i_4471 = FloatField(null=True)
    detection_stat_he_i_4471 = FloatField(null=True)
    detection_raw_he_i_4471 = FloatField(null=True)
    eqw_percentiles_he_i_4471 = ArrayField(null=True)  # ARRAY
    abs_percentiles_he_i_4471 = ArrayField(null=True)  # ARRAY
    eqw_he_ii_4685 = FloatField(null=True)
    abs_he_ii_4685 = FloatField(null=True)
    detection_stat_he_ii_4685 = FloatField(null=True)
    detection_raw_he_ii_4685 = FloatField(null=True)
    eqw_percentiles_he_ii_4685 = ArrayField(null=True)  # ARRAY
    abs_percentiles_he_ii_4685 = ArrayField(null=True)  # ARRAY
    eqw_n_ii_6583 = FloatField(null=True)
    abs_n_ii_6583 = FloatField(null=True)
    detection_stat_n_ii_6583 = FloatField(null=True)
    detection_raw_n_ii_6583 = FloatField(null=True)
    eqw_percentiles_n_ii_6583 = ArrayField(null=True)  # ARRAY
    abs_percentiles_n_ii_6583 = ArrayField(null=True)  # ARRAY
    eqw_n_ii_6548 = FloatField(null=True)
    abs_n_ii_6548 = FloatField(null=True)
    detection_stat_n_ii_6548 = FloatField(null=True)
    detection_raw_n_ii_6548 = FloatField(null=True)
    eqw_percentiles_n_ii_6548 = ArrayField(null=True)  # ARRAY
    abs_percentiles_n_ii_6548 = ArrayField(null=True)  # ARRAY
    eqw_s_ii_6716 = FloatField(null=True)
    abs_s_ii_6716 = FloatField(null=True)
    detection_stat_s_ii_6716 = FloatField(null=True)
    detection_raw_s_ii_6716 = FloatField(null=True)
    eqw_percentiles_s_ii_6716 = ArrayField(null=True)  # ARRAY
    abs_percentiles_s_ii_6716 = ArrayField(null=True)  # ARRAY
    eqw_s_ii_6730 = FloatField(null=True)
    abs_s_ii_6730 = FloatField(null=True)
    detection_stat_s_ii_6730 = FloatField(null=True)
    detection_raw_s_ii_6730 = FloatField(null=True)
    eqw_percentiles_s_ii_6730 = ArrayField(null=True)  # ARRAY
    abs_percentiles_s_ii_6730 = ArrayField(null=True)  # ARRAY
    eqw_fe_ii_5018 = FloatField(null=True)
    abs_fe_ii_5018 = FloatField(null=True)
    detection_stat_fe_ii_5018 = FloatField(null=True)
    detection_raw_fe_ii_5018 = FloatField(null=True)
    eqw_percentiles_fe_ii_5018 = ArrayField(null=True)  # ARRAY
    abs_percentiles_fe_ii_5018 = ArrayField(null=True)  # ARRAY
    eqw_fe_ii_5169 = FloatField(null=True)
    abs_fe_ii_5169 = FloatField(null=True)
    detection_stat_fe_ii_5169 = FloatField(null=True)
    detection_raw_fe_ii_5169 = FloatField(null=True)
    eqw_percentiles_fe_ii_5169 = ArrayField(null=True)  # ARRAY
    abs_percentiles_fe_ii_5169 = ArrayField(null=True)  # ARRAY
    eqw_fe_ii_5197 = FloatField(null=True)
    abs_fe_ii_5197 = FloatField(null=True)
    detection_stat_fe_ii_5197 = FloatField(null=True)
    detection_raw_fe_ii_5197 = FloatField(null=True)
    eqw_percentiles_fe_ii_5197 = ArrayField(null=True)  # ARRAY
    abs_percentiles_fe_ii_5197 = ArrayField(null=True)  # ARRAY
    eqw_fe_ii_6432 = FloatField(null=True)
    abs_fe_ii_6432 = FloatField(null=True)
    detection_stat_fe_ii_6432 = FloatField(null=True)
    detection_raw_fe_ii_6432 = FloatField(null=True)
    eqw_percentiles_fe_ii_6432 = ArrayField(null=True)  # ARRAY
    abs_percentiles_fe_ii_6432 = ArrayField(null=True)  # ARRAY
    eqw_o_i_5577 = FloatField(null=True)
    abs_o_i_5577 = FloatField(null=True)
    detection_stat_o_i_5577 = FloatField(null=True)
    detection_raw_o_i_5577 = FloatField(null=True)
    eqw_percentiles_o_i_5577 = ArrayField(null=True)  # ARRAY
    abs_percentiles_o_i_5577 = ArrayField(null=True)  # ARRAY
    eqw_o_i_6300 = FloatField(null=True)
    abs_o_i_6300 = FloatField(null=True)
    detection_stat_o_i_6300 = FloatField(null=True)
    detection_raw_o_i_6300 = FloatField(null=True)
    eqw_percentiles_o_i_6300 = ArrayField(null=True)  # ARRAY
    abs_percentiles_o_i_6300 = ArrayField(null=True)  # ARRAY
    eqw_o_i_6363 = FloatField(null=True)
    abs_o_i_6363 = FloatField(null=True)
    detection_stat_o_i_6363 = FloatField(null=True)
    detection_raw_o_i_6363 = FloatField(null=True)
    eqw_percentiles_o_i_6363 = ArrayField(null=True)  # ARRAY
    abs_percentiles_o_i_6363 = ArrayField(null=True)  # ARRAY
    eqw_o_ii_3727 = FloatField(null=True)
    abs_o_ii_3727 = FloatField(null=True)
    detection_stat_o_ii_3727 = FloatField(null=True)
    detection_raw_o_ii_3727 = FloatField(null=True)
    eqw_percentiles_o_ii_3727 = ArrayField(null=True)  # ARRAY
    abs_percentiles_o_ii_3727 = ArrayField(null=True)  # ARRAY
    eqw_o_iii_4959 = FloatField(null=True)
    abs_o_iii_4959 = FloatField(null=True)
    detection_stat_o_iii_4959 = FloatField(null=True)
    detection_raw_o_iii_4959 = FloatField(null=True)
    eqw_percentiles_o_iii_4959 = ArrayField(null=True)  # ARRAY
    abs_percentiles_o_iii_4959 = ArrayField(null=True)  # ARRAY
    eqw_o_iii_5006 = FloatField(null=True)
    abs_o_iii_5006 = FloatField(null=True)
    detection_stat_o_iii_5006 = FloatField(null=True)
    detection_raw_o_iii_5006 = FloatField(null=True)
    eqw_percentiles_o_iii_5006 = ArrayField(null=True)  # ARRAY
    abs_percentiles_o_iii_5006 = ArrayField(null=True)  # ARRAY
    eqw_o_iii_4363 = FloatField(null=True)
    abs_o_iii_4363 = FloatField(null=True)
    detection_stat_o_iii_4363 = FloatField(null=True)
    detection_raw_o_iii_4363 = FloatField(null=True)
    eqw_percentiles_o_iii_4363 = ArrayField(null=True)  # ARRAY
    abs_percentiles_o_iii_4363 = ArrayField(null=True)  # ARRAY
    eqw_li_i = FloatField(null=True)
    abs_li_i = FloatField(null=True)
    detection_stat_li_i = FloatField(null=True)
    detection_raw_li_i = FloatField(null=True)
    eqw_percentiles_li_i = ArrayField(null=True)  # ARRAY
    abs_percentiles_li_i = ArrayField(null=True)  # ARRAY

    class Meta:
        table_name = 'line_forest'
        primary_key = False


class MDwarfType(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.m_dwarf_type_task_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="mdwarf_type")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    spectral_type = TextField()
    sub_type = FloatField()
    rchi2 = FloatField()
    continuum = FloatField(null=True)
    result_flags = BigIntegerField()

    class Meta:
        table_name = 'm_dwarf_type'
        primary_key = False


class NmfRectify(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.nmf_rectify_task_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="nmf_rectify")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    log10_w = ArrayField(column_name='log10_W', null=True)  # ARRAY
    continuum_theta = ArrayField(index=True, null=True)  # ARRAY
    l = FloatField(column_name='L')
    deg = IntegerField()
    rchi2 = FloatField(null=True)
    joint_rchi2 = FloatField(null=True)
    nmf_flags = BigIntegerField(null=True)

    class Meta:
        table_name = 'nmf_rectify'
        primary_key = False


class Slam(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.slam_task_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="slam")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    teff = FloatField(null=True)
    e_teff = FloatField(null=True)
    logg = FloatField(null=True)
    e_logg = FloatField(null=True)
    fe_h = FloatField(null=True)
    e_fe_h = FloatField(null=True)
    rho_teff_logg = FloatField(null=True)
    rho_teff_fe_h = FloatField(null=True)
    rho_logg_fe_h = FloatField(null=True)
    initial_teff = FloatField(null=True)
    initial_logg = FloatField(null=True)
    initial_fe_h = FloatField(null=True)
    success = BooleanField()
    status = IntegerField()
    optimality = BooleanField()
    result_flags = BigIntegerField()
    chi2 = FloatField()
    rchi2 = FloatField()
    bad_flag = BooleanField(constraints=[SQL("DEFAULT false")], null=True)
    warn_flag = BooleanField(constraints=[SQL("DEFAULT false")], null=True)

    class Meta:
        table_name = 'slam'
        primary_key = False


class SnowWhite(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.snow_white_task_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="snow_white")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    classification = TextField(null=True)
    p_cv = FloatField(null=True)
    p_da = FloatField(null=True)
    p_dab = FloatField(null=True)
    p_dabz = FloatField(null=True)
    p_dah = FloatField(null=True)
    p_dahe = FloatField(null=True)
    p_dao = FloatField(null=True)
    p_daz = FloatField(null=True)
    p_da_ms = FloatField(null=True)
    p_db = FloatField(null=True)
    p_dba = FloatField(null=True)
    p_dbaz = FloatField(null=True)
    p_dbh = FloatField(null=True)
    p_dbz = FloatField(null=True)
    p_db_ms = FloatField(null=True)
    p_dc = FloatField(null=True)
    p_dc_ms = FloatField(null=True)
    p_do = FloatField(null=True)
    p_dq = FloatField(null=True)
    p_dqz = FloatField(null=True)
    p_dqpec = FloatField(null=True)
    p_dz = FloatField(null=True)
    p_dza = FloatField(null=True)
    p_dzb = FloatField(null=True)
    p_dzba = FloatField(null=True)
    p_mwd = FloatField(null=True)
    p_hotdq = FloatField(null=True)
    teff = FloatField(null=True)
    e_teff = FloatField(null=True)
    logg = FloatField(null=True)
    e_logg = FloatField(null=True)
    v_rel = FloatField(null=True)
    result_flags = BigIntegerField()
    raw_e_teff = DoubleField(null=True)
    raw_e_logg = DoubleField(null=True)

    class Meta:
        table_name = 'snow_white'
        primary_key = False


class SpectrumClassification(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.spectrum_classification_task_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="spectrum_classification")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    p_cv = FloatField()
    lp_cv = FloatField()
    p_fgkm = FloatField()
    lp_fgkm = FloatField()
    p_oba = FloatField()
    lp_oba = FloatField()
    p_wd = FloatField()
    lp_wd = FloatField()
    p_sb2 = FloatField()
    lp_sb2 = FloatField()
    p_yso = FloatField()
    lp_yso = FloatField()
    classification_flags = BigIntegerField()

    class Meta:
        table_name = 'spectrum_classification'
        primary_key = False


class TheCannon(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.the_cannon_task_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="the_cannon")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    teff = FloatField()
    e_teff = FloatField()
    logg = FloatField()
    e_logg = FloatField()
    fe_h = FloatField()
    e_fe_h = FloatField()
    v_micro = FloatField()
    e_v_micro = FloatField()
    v_macro = FloatField()
    e_v_macro = FloatField()
    c_fe = FloatField()
    e_c_fe = FloatField()
    n_fe = FloatField()
    e_n_fe = FloatField()
    o_fe = FloatField()
    e_o_fe = FloatField()
    na_fe = FloatField()
    e_na_fe = FloatField()
    mg_fe = FloatField()
    e_mg_fe = FloatField()
    al_fe = FloatField()
    e_al_fe = FloatField()
    si_fe = FloatField()
    e_si_fe = FloatField()
    s_fe = FloatField()
    e_s_fe = FloatField()
    k_fe = FloatField()
    e_k_fe = FloatField()
    ca_fe = FloatField()
    e_ca_fe = FloatField()
    ti_fe = FloatField()
    e_ti_fe = FloatField()
    v_fe = FloatField()
    e_v_fe = FloatField()
    cr_fe = FloatField()
    e_cr_fe = FloatField()
    mn_fe = FloatField()
    e_mn_fe = FloatField()
    ni_fe = FloatField()
    e_ni_fe = FloatField()
    chi2 = FloatField()
    rchi2 = FloatField()
    ier = IntegerField()
    nfev = IntegerField()
    x0_index = IntegerField()
    result_flags = BigIntegerField()
    raw_e_teff = DoubleField(null=True)
    raw_e_logg = DoubleField(null=True)
    raw_e_fe_h = DoubleField(null=True)
    raw_e_v_micro = DoubleField(null=True)
    raw_e_v_macro = DoubleField(null=True)
    raw_e_c_fe = DoubleField(null=True)
    raw_e_n_fe = DoubleField(null=True)
    raw_e_o_fe = DoubleField(null=True)
    raw_e_na_fe = DoubleField(null=True)
    raw_e_mg_fe = DoubleField(null=True)
    raw_e_al_fe = DoubleField(null=True)
    raw_e_si_fe = DoubleField(null=True)
    raw_e_s_fe = DoubleField(null=True)
    raw_e_k_fe = DoubleField(null=True)
    raw_e_ca_fe = DoubleField(null=True)
    raw_e_ti_fe = DoubleField(null=True)
    raw_e_v_fe = DoubleField(null=True)
    raw_e_cr_fe = DoubleField(null=True)
    raw_e_mn_fe = DoubleField(null=True)
    raw_e_ni_fe = DoubleField(null=True)

    class Meta:
        table_name = 'the_cannon'
        primary_key = False


class ThePayne(AstraBase):
    task_pk = IntegerField(constraints=[SQL("DEFAULT nextval('astra_050.the_payne_task_pk_seq'::regclass)")], unique=True)
    source = ForeignKeyField(column_name='source_pk_id', field='pk', model=Source, null=True, index=True, backref="the_payne")
    spectrum = ForeignKeyField(column_name='spectrum_pk_id', field='pk', model=Spectrum, null=True, index=True, unique=True)
    v_astra = TextField()
    created = DateTimeField()
    t_elapsed = FloatField(null=True)
    t_overhead = FloatField(null=True)
    tag = TextField(index=True)
    v_rel = FloatField(null=True)
    teff = FloatField(null=True)
    e_teff = FloatField(null=True)
    logg = FloatField(null=True)
    e_logg = FloatField(null=True)
    v_turb = FloatField(null=True)
    e_v_turb = FloatField(null=True)
    c_h = FloatField(null=True)
    e_c_h = FloatField(null=True)
    n_h = FloatField(null=True)
    e_n_h = FloatField(null=True)
    o_h = FloatField(null=True)
    e_o_h = FloatField(null=True)
    na_h = FloatField(null=True)
    e_na_h = FloatField(null=True)
    mg_h = FloatField(null=True)
    e_mg_h = FloatField(null=True)
    al_h = FloatField(null=True)
    e_al_h = FloatField(null=True)
    si_h = FloatField(null=True)
    e_si_h = FloatField(null=True)
    p_h = FloatField(null=True)
    e_p_h = FloatField(null=True)
    s_h = FloatField(null=True)
    e_s_h = FloatField(null=True)
    k_h = FloatField(null=True)
    e_k_h = FloatField(null=True)
    ca_h = FloatField(null=True)
    e_ca_h = FloatField(null=True)
    ti_h = FloatField(null=True)
    e_ti_h = FloatField(null=True)
    v_h = FloatField(null=True)
    e_v_h = FloatField(null=True)
    cr_h = FloatField(null=True)
    e_cr_h = FloatField(null=True)
    mn_h = FloatField(null=True)
    e_mn_h = FloatField(null=True)
    fe_h = FloatField(null=True)
    e_fe_h = FloatField(null=True)
    co_h = FloatField(null=True)
    e_co_h = FloatField(null=True)
    ni_h = FloatField(null=True)
    e_ni_h = FloatField(null=True)
    cu_h = FloatField(null=True)
    e_cu_h = FloatField(null=True)
    ge_h = FloatField(null=True)
    e_ge_h = FloatField(null=True)
    c12_c13 = FloatField(null=True)
    e_c12_c13 = FloatField(null=True)
    v_macro = FloatField(null=True)
    e_v_macro = FloatField(null=True)
    chi2 = FloatField(null=True)
    reduced_chi2 = FloatField(null=True)
    result_flags = BigIntegerField()
    rho_teff_logg = FloatField(null=True)
    rho_teff_v_turb = FloatField(null=True)
    rho_teff_c_h = FloatField(null=True)
    rho_teff_n_h = FloatField(null=True)
    rho_teff_o_h = FloatField(null=True)
    rho_teff_na_h = FloatField(null=True)
    rho_teff_mg_h = FloatField(null=True)
    rho_teff_al_h = FloatField(null=True)
    rho_teff_si_h = FloatField(null=True)
    rho_teff_p_h = FloatField(null=True)
    rho_teff_s_h = FloatField(null=True)
    rho_teff_k_h = FloatField(null=True)
    rho_teff_ca_h = FloatField(null=True)
    rho_teff_ti_h = FloatField(null=True)
    rho_teff_v_h = FloatField(null=True)
    rho_teff_cr_h = FloatField(null=True)
    rho_teff_mn_h = FloatField(null=True)
    rho_teff_fe_h = FloatField(null=True)
    rho_teff_co_h = FloatField(null=True)
    rho_teff_ni_h = FloatField(null=True)
    rho_teff_cu_h = FloatField(null=True)
    rho_teff_ge_h = FloatField(null=True)
    rho_teff_c12_c13 = FloatField(null=True)
    rho_teff_v_macro = FloatField(null=True)
    rho_logg_v_turb = FloatField(null=True)
    rho_logg_c_h = FloatField(null=True)
    rho_logg_n_h = FloatField(null=True)
    rho_logg_o_h = FloatField(null=True)
    rho_logg_na_h = FloatField(null=True)
    rho_logg_mg_h = FloatField(null=True)
    rho_logg_al_h = FloatField(null=True)
    rho_logg_si_h = FloatField(null=True)
    rho_logg_p_h = FloatField(null=True)
    rho_logg_s_h = FloatField(null=True)
    rho_logg_k_h = FloatField(null=True)
    rho_logg_ca_h = FloatField(null=True)
    rho_logg_ti_h = FloatField(null=True)
    rho_logg_v_h = FloatField(null=True)
    rho_logg_cr_h = FloatField(null=True)
    rho_logg_mn_h = FloatField(null=True)
    rho_logg_fe_h = FloatField(null=True)
    rho_logg_co_h = FloatField(null=True)
    rho_logg_ni_h = FloatField(null=True)
    rho_logg_cu_h = FloatField(null=True)
    rho_logg_ge_h = FloatField(null=True)
    rho_logg_c12_c13 = FloatField(null=True)
    rho_logg_v_macro = FloatField(null=True)
    rho_v_turb_c_h = FloatField(null=True)
    rho_v_turb_n_h = FloatField(null=True)
    rho_v_turb_o_h = FloatField(null=True)
    rho_v_turb_na_h = FloatField(null=True)
    rho_v_turb_mg_h = FloatField(null=True)
    rho_v_turb_al_h = FloatField(null=True)
    rho_v_turb_si_h = FloatField(null=True)
    rho_v_turb_p_h = FloatField(null=True)
    rho_v_turb_s_h = FloatField(null=True)
    rho_v_turb_k_h = FloatField(null=True)
    rho_v_turb_ca_h = FloatField(null=True)
    rho_v_turb_ti_h = FloatField(null=True)
    rho_v_turb_v_h = FloatField(null=True)
    rho_v_turb_cr_h = FloatField(null=True)
    rho_v_turb_mn_h = FloatField(null=True)
    rho_v_turb_fe_h = FloatField(null=True)
    rho_v_turb_co_h = FloatField(null=True)
    rho_v_turb_ni_h = FloatField(null=True)
    rho_v_turb_cu_h = FloatField(null=True)
    rho_v_turb_ge_h = FloatField(null=True)
    rho_v_turb_c12_c13 = FloatField(null=True)
    rho_v_turb_v_macro = FloatField(null=True)
    rho_c_h_n_h = FloatField(null=True)
    rho_c_h_o_h = FloatField(null=True)
    rho_c_h_na_h = FloatField(null=True)
    rho_c_h_mg_h = FloatField(null=True)
    rho_c_h_al_h = FloatField(null=True)
    rho_c_h_si_h = FloatField(null=True)
    rho_c_h_p_h = FloatField(null=True)
    rho_c_h_s_h = FloatField(null=True)
    rho_c_h_k_h = FloatField(null=True)
    rho_c_h_ca_h = FloatField(null=True)
    rho_c_h_ti_h = FloatField(null=True)
    rho_c_h_v_h = FloatField(null=True)
    rho_c_h_cr_h = FloatField(null=True)
    rho_c_h_mn_h = FloatField(null=True)
    rho_c_h_fe_h = FloatField(null=True)
    rho_c_h_co_h = FloatField(null=True)
    rho_c_h_ni_h = FloatField(null=True)
    rho_c_h_cu_h = FloatField(null=True)
    rho_c_h_ge_h = FloatField(null=True)
    rho_c_h_c12_c13 = FloatField(null=True)
    rho_c_h_v_macro = FloatField(null=True)
    rho_n_h_o_h = FloatField(null=True)
    rho_n_h_na_h = FloatField(null=True)
    rho_n_h_mg_h = FloatField(null=True)
    rho_n_h_al_h = FloatField(null=True)
    rho_n_h_si_h = FloatField(null=True)
    rho_n_h_p_h = FloatField(null=True)
    rho_n_h_s_h = FloatField(null=True)
    rho_n_h_k_h = FloatField(null=True)
    rho_n_h_ca_h = FloatField(null=True)
    rho_n_h_ti_h = FloatField(null=True)
    rho_n_h_v_h = FloatField(null=True)
    rho_n_h_cr_h = FloatField(null=True)
    rho_n_h_mn_h = FloatField(null=True)
    rho_n_h_fe_h = FloatField(null=True)
    rho_n_h_co_h = FloatField(null=True)
    rho_n_h_ni_h = FloatField(null=True)
    rho_n_h_cu_h = FloatField(null=True)
    rho_n_h_ge_h = FloatField(null=True)
    rho_n_h_c12_c13 = FloatField(null=True)
    rho_n_h_v_macro = FloatField(null=True)
    rho_o_h_na_h = FloatField(null=True)
    rho_o_h_mg_h = FloatField(null=True)
    rho_o_h_al_h = FloatField(null=True)
    rho_o_h_si_h = FloatField(null=True)
    rho_o_h_p_h = FloatField(null=True)
    rho_o_h_s_h = FloatField(null=True)
    rho_o_h_k_h = FloatField(null=True)
    rho_o_h_ca_h = FloatField(null=True)
    rho_o_h_ti_h = FloatField(null=True)
    rho_o_h_v_h = FloatField(null=True)
    rho_o_h_cr_h = FloatField(null=True)
    rho_o_h_mn_h = FloatField(null=True)
    rho_o_h_fe_h = FloatField(null=True)
    rho_o_h_co_h = FloatField(null=True)
    rho_o_h_ni_h = FloatField(null=True)
    rho_o_h_cu_h = FloatField(null=True)
    rho_o_h_ge_h = FloatField(null=True)
    rho_o_h_c12_c13 = FloatField(null=True)
    rho_o_h_v_macro = FloatField(null=True)
    rho_na_h_mg_h = FloatField(null=True)
    rho_na_h_al_h = FloatField(null=True)
    rho_na_h_si_h = FloatField(null=True)
    rho_na_h_p_h = FloatField(null=True)
    rho_na_h_s_h = FloatField(null=True)
    rho_na_h_k_h = FloatField(null=True)
    rho_na_h_ca_h = FloatField(null=True)
    rho_na_h_ti_h = FloatField(null=True)
    rho_na_h_v_h = FloatField(null=True)
    rho_na_h_cr_h = FloatField(null=True)
    rho_na_h_mn_h = FloatField(null=True)
    rho_na_h_fe_h = FloatField(null=True)
    rho_na_h_co_h = FloatField(null=True)
    rho_na_h_ni_h = FloatField(null=True)
    rho_na_h_cu_h = FloatField(null=True)
    rho_na_h_ge_h = FloatField(null=True)
    rho_na_h_c12_c13 = FloatField(null=True)
    rho_na_h_v_macro = FloatField(null=True)
    rho_mg_h_al_h = FloatField(null=True)
    rho_mg_h_si_h = FloatField(null=True)
    rho_mg_h_p_h = FloatField(null=True)
    rho_mg_h_s_h = FloatField(null=True)
    rho_mg_h_k_h = FloatField(null=True)
    rho_mg_h_ca_h = FloatField(null=True)
    rho_mg_h_ti_h = FloatField(null=True)
    rho_mg_h_v_h = FloatField(null=True)
    rho_mg_h_cr_h = FloatField(null=True)
    rho_mg_h_mn_h = FloatField(null=True)
    rho_mg_h_fe_h = FloatField(null=True)
    rho_mg_h_co_h = FloatField(null=True)
    rho_mg_h_ni_h = FloatField(null=True)
    rho_mg_h_cu_h = FloatField(null=True)
    rho_mg_h_ge_h = FloatField(null=True)
    rho_mg_h_c12_c13 = FloatField(null=True)
    rho_mg_h_v_macro = FloatField(null=True)
    rho_al_h_si_h = FloatField(null=True)
    rho_al_h_p_h = FloatField(null=True)
    rho_al_h_s_h = FloatField(null=True)
    rho_al_h_k_h = FloatField(null=True)
    rho_al_h_ca_h = FloatField(null=True)
    rho_al_h_ti_h = FloatField(null=True)
    rho_al_h_v_h = FloatField(null=True)
    rho_al_h_cr_h = FloatField(null=True)
    rho_al_h_mn_h = FloatField(null=True)
    rho_al_h_fe_h = FloatField(null=True)
    rho_al_h_co_h = FloatField(null=True)
    rho_al_h_ni_h = FloatField(null=True)
    rho_al_h_cu_h = FloatField(null=True)
    rho_al_h_ge_h = FloatField(null=True)
    rho_al_h_c12_c13 = FloatField(null=True)
    rho_al_h_v_macro = FloatField(null=True)
    rho_si_h_p_h = FloatField(null=True)
    rho_si_h_s_h = FloatField(null=True)
    rho_si_h_k_h = FloatField(null=True)
    rho_si_h_ca_h = FloatField(null=True)
    rho_si_h_ti_h = FloatField(null=True)
    rho_si_h_v_h = FloatField(null=True)
    rho_si_h_cr_h = FloatField(null=True)
    rho_si_h_mn_h = FloatField(null=True)
    rho_si_h_fe_h = FloatField(null=True)
    rho_si_h_co_h = FloatField(null=True)
    rho_si_h_ni_h = FloatField(null=True)
    rho_si_h_cu_h = FloatField(null=True)
    rho_si_h_ge_h = FloatField(null=True)
    rho_si_h_c12_c13 = FloatField(null=True)
    rho_si_h_v_macro = FloatField(null=True)
    rho_p_h_s_h = FloatField(null=True)
    rho_p_h_k_h = FloatField(null=True)
    rho_p_h_ca_h = FloatField(null=True)
    rho_p_h_ti_h = FloatField(null=True)
    rho_p_h_v_h = FloatField(null=True)
    rho_p_h_cr_h = FloatField(null=True)
    rho_p_h_mn_h = FloatField(null=True)
    rho_p_h_fe_h = FloatField(null=True)
    rho_p_h_co_h = FloatField(null=True)
    rho_p_h_ni_h = FloatField(null=True)
    rho_p_h_cu_h = FloatField(null=True)
    rho_p_h_ge_h = FloatField(null=True)
    rho_p_h_c12_c13 = FloatField(null=True)
    rho_p_h_v_macro = FloatField(null=True)
    rho_s_h_k_h = FloatField(null=True)
    rho_s_h_ca_h = FloatField(null=True)
    rho_s_h_ti_h = FloatField(null=True)
    rho_s_h_v_h = FloatField(null=True)
    rho_s_h_cr_h = FloatField(null=True)
    rho_s_h_mn_h = FloatField(null=True)
    rho_s_h_fe_h = FloatField(null=True)
    rho_s_h_co_h = FloatField(null=True)
    rho_s_h_ni_h = FloatField(null=True)
    rho_s_h_cu_h = FloatField(null=True)
    rho_s_h_ge_h = FloatField(null=True)
    rho_s_h_c12_c13 = FloatField(null=True)
    rho_s_h_v_macro = FloatField(null=True)
    rho_k_h_ca_h = FloatField(null=True)
    rho_k_h_ti_h = FloatField(null=True)
    rho_k_h_v_h = FloatField(null=True)
    rho_k_h_cr_h = FloatField(null=True)
    rho_k_h_mn_h = FloatField(null=True)
    rho_k_h_fe_h = FloatField(null=True)
    rho_k_h_co_h = FloatField(null=True)
    rho_k_h_ni_h = FloatField(null=True)
    rho_k_h_cu_h = FloatField(null=True)
    rho_k_h_ge_h = FloatField(null=True)
    rho_k_h_c12_c13 = FloatField(null=True)
    rho_k_h_v_macro = FloatField(null=True)
    rho_ca_h_ti_h = FloatField(null=True)
    rho_ca_h_v_h = FloatField(null=True)
    rho_ca_h_cr_h = FloatField(null=True)
    rho_ca_h_mn_h = FloatField(null=True)
    rho_ca_h_fe_h = FloatField(null=True)
    rho_ca_h_co_h = FloatField(null=True)
    rho_ca_h_ni_h = FloatField(null=True)
    rho_ca_h_cu_h = FloatField(null=True)
    rho_ca_h_ge_h = FloatField(null=True)
    rho_ca_h_c12_c13 = FloatField(null=True)
    rho_ca_h_v_macro = FloatField(null=True)
    rho_ti_h_v_h = FloatField(null=True)
    rho_ti_h_cr_h = FloatField(null=True)
    rho_ti_h_mn_h = FloatField(null=True)
    rho_ti_h_fe_h = FloatField(null=True)
    rho_ti_h_co_h = FloatField(null=True)
    rho_ti_h_ni_h = FloatField(null=True)
    rho_ti_h_cu_h = FloatField(null=True)
    rho_ti_h_ge_h = FloatField(null=True)
    rho_ti_h_c12_c13 = FloatField(null=True)
    rho_ti_h_v_macro = FloatField(null=True)
    rho_v_h_cr_h = FloatField(null=True)
    rho_v_h_mn_h = FloatField(null=True)
    rho_v_h_fe_h = FloatField(null=True)
    rho_v_h_co_h = FloatField(null=True)
    rho_v_h_ni_h = FloatField(null=True)
    rho_v_h_cu_h = FloatField(null=True)
    rho_v_h_ge_h = FloatField(null=True)
    rho_v_h_c12_c13 = FloatField(null=True)
    rho_v_h_v_macro = FloatField(null=True)
    rho_cr_h_mn_h = FloatField(null=True)
    rho_cr_h_fe_h = FloatField(null=True)
    rho_cr_h_co_h = FloatField(null=True)
    rho_cr_h_ni_h = FloatField(null=True)
    rho_cr_h_cu_h = FloatField(null=True)
    rho_cr_h_ge_h = FloatField(null=True)
    rho_cr_h_c12_c13 = FloatField(null=True)
    rho_cr_h_v_macro = FloatField(null=True)
    rho_mn_h_fe_h = FloatField(null=True)
    rho_mn_h_co_h = FloatField(null=True)
    rho_mn_h_ni_h = FloatField(null=True)
    rho_mn_h_cu_h = FloatField(null=True)
    rho_mn_h_ge_h = FloatField(null=True)
    rho_mn_h_c12_c13 = FloatField(null=True)
    rho_mn_h_v_macro = FloatField(null=True)
    rho_fe_h_co_h = FloatField(null=True)
    rho_fe_h_ni_h = FloatField(null=True)
    rho_fe_h_cu_h = FloatField(null=True)
    rho_fe_h_ge_h = FloatField(null=True)
    rho_fe_h_c12_c13 = FloatField(null=True)
    rho_fe_h_v_macro = FloatField(null=True)
    rho_co_h_ni_h = FloatField(null=True)
    rho_co_h_cu_h = FloatField(null=True)
    rho_co_h_ge_h = FloatField(null=True)
    rho_co_h_c12_c13 = FloatField(null=True)
    rho_co_h_v_macro = FloatField(null=True)
    rho_ni_h_cu_h = FloatField(null=True)
    rho_ni_h_ge_h = FloatField(null=True)
    rho_ni_h_c12_c13 = FloatField(null=True)
    rho_ni_h_v_macro = FloatField(null=True)
    rho_cu_h_ge_h = FloatField(null=True)
    rho_cu_h_c12_c13 = FloatField(null=True)
    rho_cu_h_v_macro = FloatField(null=True)
    rho_ge_h_c12_c13 = FloatField(null=True)
    rho_ge_h_v_macro = FloatField(null=True)
    rho_c12_c13_v_macro = FloatField(null=True)
    raw_e_teff = DoubleField(null=True)
    raw_e_logg = DoubleField(null=True)
    raw_e_v_turb = DoubleField(null=True)
    raw_e_c_h = DoubleField(null=True)
    raw_e_n_h = DoubleField(null=True)
    raw_e_o_h = DoubleField(null=True)
    raw_e_na_h = DoubleField(null=True)
    raw_e_mg_h = DoubleField(null=True)
    raw_e_al_h = DoubleField(null=True)
    raw_e_si_h = DoubleField(null=True)
    raw_e_p_h = DoubleField(null=True)
    raw_e_s_h = DoubleField(null=True)
    raw_e_k_h = DoubleField(null=True)
    raw_e_ca_h = DoubleField(null=True)
    raw_e_ti_h = DoubleField(null=True)
    raw_e_v_h = DoubleField(null=True)
    raw_e_cr_h = DoubleField(null=True)
    raw_e_mn_h = DoubleField(null=True)
    raw_e_fe_h = DoubleField(null=True)
    raw_e_co_h = DoubleField(null=True)
    raw_e_ni_h = DoubleField(null=True)
    raw_e_cu_h = DoubleField(null=True)
    raw_e_ge_h = DoubleField(null=True)
    raw_e_c12_c13 = DoubleField(null=True)
    raw_e_v_macro = DoubleField(null=True)

    class Meta:
        table_name = 'the_payne'
        primary_key = False
